`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/04/09 23:23:40
// Design Name: 
// Module Name: fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define PAUSE 0 // pause state
`define START 1 // start state
`define ENABLED 1
`define DISABLED 0

module fsm(
    input rst_n,
    input clk,
    input in,
    output reg cnt_en
    );
    reg state;
    reg next_state;

// FSM state decision
always@*
    case (state)
        `PAUSE:
        if (in)
            begin
                next_state = `START;
                cnt_en = `ENABLED;
            end
        else
            begin
                next_state = `PAUSE;
                cnt_en = `DISABLED;
            end
        `START:
            if (in)
                begin
                    next_state = `PAUSE;
                    cnt_en = `DISABLED;
                end
            else
                begin
                    next_state = `START;
                    cnt_en = `ENABLED;
                end
        default:
            begin
                next_state = `PAUSE;
                cnt_en = `DISABLED;
            end
    endcase

// FSM state transition
always@(posedge clk or negedge rst_n)
    if (~rst_n)
        state <= `PAUSE;
    else
        state <= next_state;

endmodule
