`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/04/10 00:17:57
// Design Name: 
// Module Name: stopwatch
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module stopwatch(
    input clk,
    input rst_n,
    input pb_in,
    output [15:0]led,
    output [3:0]ssd_ctl,
    output [7:0]segs
    );
    wire [1:0]ssd_ctl_en;
    wire clk_1Hz;
    wire pb_pulse;
    wire cnt_en;
    wire [3:0]digit1;
    wire [3:0]digit0;
    wire [3:0]ssd_in;

top U3(
    .clk(clk),
    .pb_in(pb_in),
    .rst_n(rst_n),
    .ssd_ctl_en(ssd_ctl_en),
    .clk_1Hz(clk_1Hz),
    .pb_pulse(pb_pulse)
);

fsm U4(
    .rst_n(~rst_n),
    .clk(clk_1Hz),
    .in(pb_pulse),
    .cnt_en(cnt_en)
);

BCD_down_cnt_2digit U5(
    .clk(clk_1Hz),
    .rst_n(~rst_n),
    .cnt_en(cnt_en),
    .value0(digit0),
    .value1(digit1)
);

LED U6(
    .in0(digit0),
    .in1(digit1),
    .led(led)
);

scan_ctl U7(
    .ssd_ctl_en(ssd_ctl_en),
    .in3(4'b1111),
    .in2(4'b1111),
    .in1(digit1),
    .in0(digit0),
    .ssd_ctl(ssd_ctl),
    .ssd_in(ssd_in)
);

display U8(
    .in(ssd_in),
    .segs(segs)
);

endmodule
